#ifndef DEVICE_H_
#define DEVICE_H_

#define EP0_SIZE            8                  // 8 is just for testing could be also 16 / 32 / 64
#define BULK_SIZE           64                 // bulks are always 64 bytes for usb1.1
#define FREQ_SYS            6000000L           // operating at 6 MHz


#define LED1    P3_3                           // led at P3.3
#define LED2    P1_1                           // led at P1.1
#define LED_OFF 1                              // leds are low active
#define LED_ON  0


#define USB_STATE_POWERED   0                  // maintaining the enum state
#define USB_STATE_RESET     1
#define USB_STATE_ADDRESSED 2
#define USB_STATE_CONFIG    3
#define USB_STATE_SUSPEND   4

#define LED_TIMEOUT           1                  //   2 ms
#define SENSE_TIMEOUT       150                  // 300 ms
  
#define MIDIBUF_SIZE        (128)                // has to be 2^n here 128 bytes 
#define MIDIBUF_MASK        (MIDIBUF_SIZE-1)     // mask for overflow corrections
#define MIDIBUF_UPPER       (MIDIBUF_SIZE *2/3)  // upper limit for taking action not used    
#define MIDIBUF_LOWER       (MIDIBUF_SIZE *1/3)  // used to free the bulk out buffer 

typedef struct _MESSAGE
{
   uint8_t Cnt;    //number of valid bytes
   uint8_t Buf[3]; //buffer
}tMSG;

typedef struct _FIFOCTL
{
	 uint8_t wr;     // wr index
	 uint8_t rd;     // rd index
   uint8_t level;  // fillgrade
}tFIFOCTL;

typedef struct _SETUP
{
    uint8_t  bRequestType;
    uint8_t  bRequest;
    uint8_t  wValueLo;
    uint8_t  wValueHi;
    uint8_t  wIndexLo;
    uint8_t  wIndexHi;
    uint16_t wLength;
}tSETUP;

#endif